package SortAlgori;

public class MergeSort {

    private int[] arr;

    private int[] temp;

    public int[] getArr() {
        return arr;
    }

    public void setArr(int[] arr) {
        this.arr = arr;
    }

    public MergeSort(int[] arr){
        this.arr = arr;
//        this.arr = new int[]{8,4,5,7,1,3,6,2};
        this.temp = new int[arr.length];
    }

    public void mergeSort(int left, int right){
        while(left >= right){
            return;
        }
        int mid = (left + right)/2;
        mergeSort(left,mid);
        mergeSort(mid+1,right);

        int leftIndex = left;
        int rightIndex = mid+1;
        int index = left;
        while(index <= right){
            if(arr[leftIndex] <= arr[rightIndex]){
                temp[index] = arr[leftIndex];
                leftIndex ++;
                index ++;
            }else{
                temp[index] = arr[rightIndex];
                rightIndex ++;
                index ++;
            }
            if(leftIndex > mid){
                while(rightIndex <= right){
                    temp[index] = arr[rightIndex];
                    rightIndex ++;
                    index ++;
                }
                break;
            }
            if(rightIndex > right){
                while(leftIndex <= mid){
                    temp[index] = arr[leftIndex];
                    leftIndex ++;
                    index ++;
                }
                break;
            }
        }

        for(int i=left; i<=right; i++){
            arr[i] = temp[i];
        }

    }

    public void show(){
        for (int i = 0; i < arr.length; i++) {
            System.out.print(arr[i] + " ");
        }
        System.out.println();
    }

    public static void main(String[] args) {
        int[] arr = new int[80000];
        System.out.println("排序前的序列：");
        for(int i=0; i<80000; i++){
            arr[i] = (int)(Math.random()*100000);
            System.out.print(arr[i] + " ");
        }
        MergeSort mergeSort = new MergeSort(arr);
        long startTime = System.currentTimeMillis();
        mergeSort.mergeSort(0,arr.length-1);
        long endTime = System.currentTimeMillis();
        System.out.println("排序后的序列：");
        mergeSort.show();
        System.out.println("排序所花费的时间：" + (endTime - startTime) + "ms");
    }
}
